/*
 * .vantronix | gvoid11 (gtk+ 802.11b penetration testing utility)
 *
 * Copyright (c) 2002-2004, Reyk Floeter <reyk@vantronix.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#ifndef _GVOID11_MAIN_H
#define _GVOID11_MAIN_H

#include <void11.h>
#include <pthread.h>

enum {
  GVOID11_COL_SESSION = 0,
  GVOID11_COL_CHANNEL,
  GVOID11_COL_BSSID,
  GVOID11_COL_SSID,
  GVOID11_COL_TIMEOUT,
  GVOID11_COL_STATUS,
};

enum {
  GVOID11_HOPPER_LINEAR = 0,
  GVOID11_HOPPER_RANDOM,
};

extern GtkWidget *gvoid11, *gvoid11_readme;
extern GtkWidget *dialog_about;

extern int list_store_cols;
extern GtkListStore *list_store;
extern GtkTreeModel *list_model;
extern GtkTreeView *list_widget;

struct entry {
  enum { MATCH_BSSID, MATCH_SSID } match_type;
  struct void11_ap *ap;
  int slot;
  pthread_t thread;
  LIST_ENTRY(entry) entries;
};

struct iter {
  GtkTreeIter iter;
  pthread_mutex_t mutex;
  int used;
};

extern struct iter *gvoid11_iter;

extern int debug;
extern int delay;
extern int type;
extern int max_clients;
extern int timeout;
extern int void11_match;
extern int client_connections;
extern int match_ssid;
extern int running;
extern int hopper_mode, hopper_start, hopper_stop, hopper_delay;
extern pid_t ppid;
extern char *staptr;
extern char interface[IFNAMSIZ];
extern hostapd void11;

extern struct aps_head *aps_headp;   
extern struct entry  *aps_black, *aps_match;

extern pthread_t listen_thread, hopper_thread;

extern void gvoid11_exit(void);
extern int gvoid11_init(void);
extern void gvoid11_setup(void);
extern void gvoid11_warning(char *);
extern void *gvoid11_listen(void *);
extern void gvoid11_protect(gboolean);
extern int gvoid11_randval(int, int);

extern void *gvoid11_hopper(void *);

/* some random stolen from openbsd... hrhr */
extern u_int32_t arc4random(void);

/* display our readme file */
extern void gvoid11_show_readme(void);

#endif /* _GVOID11_MAIN_H */
